/*
    AGGRESSIVE PONG.
    Copyright (C) 2010  Eugene Popov (popov_e_n@mail.ru)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

#define PRIZEREG_SIZE 3
#define BULLETREG_SIZE 6

global
  int bullets0[ BULLETREG_SIZE ]; // <--- this player
  int prizes0 [ PRIZEREG_SIZE ];
  int bullets1[ BULLETREG_SIZE ]; // this player --->
  int prizes1 [ PRIZEREG_SIZE ];
end;

/*--------------------------------------------------------*/
/// TODO отлов минимума-максимаума модно сделать только при изменеии массивов, но эт потом
function prize_reg( int idprize, int side )
local int i, *ptr; end
begin
  ptr = side ? &prizes1 : &prizes0;
  for( i = 0; i<PRIZEREG_SIZE-1; i++)
    if( !exists(ptr[i]) )
      ptr[i] = idprize;
      //say('registred at side '+side);
      return;
    end
  end
  ptr[i] = idprize;
end

/*--------------------------------------------------------*/

function bullet_reg( int idbullet, int side )
local int i, *ptr; end
begin
  ptr = side ? &bullets1 : &bullets0;
  for( i = 0; i<BULLETREG_SIZE-1; i++)
    if( !exists(ptr[i]) )
      ptr[i] = idbullet;
      return;
    end
  end
  ptr[i] = idbullet;
end

/*--------------------------------------------------------*/

function prize_closest( int side )
local int i, *ptr, xm, xi; end
begin
  if( side )
    ptr = &prizes1;
    xm  = 0;
    xi = -1;
    for( i = 0; i<PRIZEREG_SIZE; i++)
      if( exists(ptr[i]) && ptr[i].x > xm )
	xm = ptr[i];
	xi = i;
	//say('closest!');
      end
    end
    return xi<0 ? 0 : ptr[xi];
  else
    ptr = &prizes0;
    xm  = scr_width();
    xi = -1;
    for( i = 0; i<PRIZEREG_SIZE; i++)
      if( exists(ptr[i]) && ptr[i].x < xm )
	xm = ptr[i];
	xi = i;
      end
    end
    return xi<0 ? 0 : ptr[xi];
  end
end

/*--------------------------------------------------------*/

function bullet_closest( int side )
local int i, *ptr, xm, xi; end
begin
  if( side )
    ptr = &bullets1;
    xm  = 0;
    xi = -1;
    for( i = 0; i<PRIZEREG_SIZE; i++)
      if( exists(ptr[i]) && ptr[i].x > xm )
	xm = ptr[i];
	xi = i;
      end
    end
    return xi<0 ? 0 : ptr[xi];
  else
    ptr = &bullets0;
    xm  = scr_width();
    xi = -1;
    for( i = 0; i<PRIZEREG_SIZE; i++)
      if( exists(ptr[i]) && ptr[i].x < xm )
	xm = ptr[i];
	xi = i;
      end
    end
    return xi<0 ? 0 : ptr[xi];
  end
end

/*--------------------------------------------------------*/

function int select_prize()
local int p; end
begin
 // return rand(0,1)?PL_I_DAMAGE:PL_I_NROCKET;	
  //return PL_I_STOPBALL;
 // return PL_I_WALL;
  /*
  PL_I_HEAVY     25%
  PL_I_STOPBALL  10%
  PL_I_EQUALIZE  15%
  PL_I_DAMAGE    25%
  PL_I_NROCKET   25%
  */
  if( rand( 1, 4 ) == 1 )
    p = rand(0,99);
    if( p < 25) return PL_I_HEAVY; end
    if( p < 35) return PL_I_STOPBALL;     end
    if( p < 50) return PL_I_EQUALIZE;    end
    if( p < 75) return PL_I_DAMAGE;  end
    if( p < 100)return PL_I_NROCKET;    end
  else
    /*
    PL_I_SURIKEN 20%
    PL_I_AXE     5%
    PL_I_WALL    10%
    PL_I_MANA    45%
    PL_I_BROCKET 6%
    PL_I_BINVIS  6%
    PL_I_WIDE    8%
    */  
    p = rand(0,99);
    if( p < 20) return PL_I_SURIKEN; end
    if( p < 25) return PL_I_AXE;     end
    if( p < 35) return PL_I_WALL;    end
    if( p < 80) return PL_I_MANA;    end
    if( p < 86) return PL_I_BROCKET; end
    if( p < 92) return PL_I_BINVIS;  end
    if( p < 100)return PL_I_WIDE;    end
    return PL_I_MANA;
  end
end
