/*
#define scr_width() ( graphic_info(0, 0, G_WIDTH ) )
#define scr_height() ( graphic_info(0, 0, G_HEIGHT ) )
*/
#define scr_width() ( gam_scr_width )
#define scr_height() ( gam_scr_height )

#define scr_midx() ( gam_scr_midx )
#define scr_midy() ( gam_scr_midy )

global

  int gam_scr_height;
  int gam_scr_width;
  int gam_scr_midx;
  int gam_scr_midy;
  int gam_scr_fps;
  
end;


function detect_resolutions( int bpp, int flg )
local
  int *ptr;
  int ww, hh;
begin
  ptr = get_modes( bpp, flg );
  if(ptr==NULL)
    say("No screen modes avail ("+bpp+","+flg+")");
    return;
  end;
  if(ptr==-1)
    say("ANY screen mode avail ("+bpp+","+flg+")");
    return;
  end;
  while(*ptr)
    ww = *ptr;
    ptr++;
    hh = *ptr;
    ptr++;
    say("mode avail: "+ww+"x"+hh);
  end;
  
end

