/*
    Bennu Convinience Lib Set.
    Copyright (C) 2010  Eugene Popov (popov_e_n@mail.ru)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

process scroller()
public
  int vx=0, vy=0;
end
begin
  loop
    scroll[0].x0 += vx;
    scroll[0].y0 += vy;
    frame 120;
  end
end

global
    scroller scroll_xx;
end

function init_scroller(int g)
begin
  start_scroll( 0, file, g, 0, 0, 1 | 2 ); //
  scroll_xx = scroller();
end

function  set_scroll(int vx, int vy)
begin
  scroll_xx.vx = vx;
  scroll_xx.vy = vy;
end